Commit | Line | Data |
---|---|---|
2ea4288a | 1 | #!/bin/bash |
2ea4288a | 2 | # Desc: Template to check that apps, files, or dirs exist. |
5ef33b04 | 3 | # Author: Steven Baltaktei Sandoval; License: GPLv3+ |
2ea4288a SBS |
4 | |
5 | #==BEGIN Define script parameters== | |
6 | #===BEGIN Declare local script functions=== | |
5ef33b04 SBS |
7 | yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370 |
8 | die() { yell "$*"; exit 111; } | |
9 | try() { "$@" || die "cannot $*"; } | |
2ea4288a SBS |
10 | timeUntilMidnight(){ |
11 | # Desc: Report seconds until midnight | |
5ef33b04 SBS |
12 | # Output: stdout: integer seconds until midnight |
13 | # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0 | |
14 | # Usage: timeUntilMidnight | |
15 | # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi | |
16 | local returnState | |
2ea4288a SBS |
17 | TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second. |
18 | TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second. | |
19 | DATE_CURRENT="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day. | |
20 | DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day. | |
21 | DATE_TOMORROW="$(date -d "$TIME_CURRENT next day" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day). | |
22 | TIME_NEXT_MIDNIGHT="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second). | |
23 | SECONDS_UNTIL_NEXT_MIDNIGHT="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second). | |
5ef33b04 SBS |
24 | if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then |
25 | returnState="true"; | |
26 | elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then | |
27 | returnState="WARNING_ZERO"; | |
28 | yell "WARNING:Reported time until midnight exactly zero."; | |
29 | elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then | |
30 | returnState="WARNING_NEGATIVE"; | |
31 | yell "WARNING:Reported time until midnight is negative."; | |
32 | fi | |
33 | ||
34 | try echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report | |
35 | ||
36 | #===Determine function return code=== | |
37 | if [[ "$returnState" = "true" ]]; then | |
38 | return 0; | |
39 | elif [[ "$returnState" = "WARNING_ZERO" ]]; then | |
40 | return 1; | |
41 | elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then | |
42 | return 2; | |
43 | fi | |
2ea4288a SBS |
44 | } # Report seconds until next midnight |
45 | #===END Declare local script functions=== | |
46 | #==END Define script parameters== | |
47 | ||
48 | ||
49 | #==BEGIN sample code== | |
5ef33b04 SBS |
50 | try echo "Time until next midnight (seconds):$(timeUntilMidnight)" # simple report |
51 | ||
52 | if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0. | |
2ea4288a | 53 | #==END sample code== |